/* local.h - Definitions for use with Reliable Data Structures in C */
#ifndef LOCAL_H
#define LOCAL_H
#include <stdio.h>
#include <ctype.h>
#include <math.h>
#define FALSE			0			/* Boolean value */
#define FOREVER			for(;;)		/* endless loop */
#define NO				0			/* Boolean value */
#define TRUE			1			/* Boolean value */
#define YES				1			/* Boolean value */
#define getln(s, n)		((fgets(s, n, stdin)==NULL) ? EOF : strlen(s))
#define ABS(x)			(((x) < 0) ? -(x) : (x))
#define MAX(x, y)		(((x) < (y)) ? (y) : (x))
#define MIN(x, y)		(((x) < (y)) ? (x) : (y))
#define DIM(a)			(sizeof(a) / sizeof(a[0]))
#define IN_RANGE(n, lo, hi) ((lo) <= (n) && (n) <= (hi))
#ifndef NDEBUG
#define asserts(cond, str) \
	{if (!(cond)) fprintf(stderr, "Assertion '%s' failed\n", str);}
#else
#define asserts(cond, str)
#endif
#define SWAP(a, b, t) 	((t) = (a), (a) = (b), (b) = (t))
#define LOOPDN(r, n)	for ((r) = (n)+1; --(r) > 0; )
#define STREQ(s, t)		(strcmp(s, t) == 0)
#define STRLT(s, t)		(strcmp(s, t) < 0)
#define STRGT(s, t)		(strcmp(s, t) > 0)
#include "portdefs.h"	/* portability definitions */
#include "stddef.h"		/* (ANSI) standard definitions */
#include "limits.h"		/* (ANSI) machine parameters */
#include "string.h"		/* (ANSI) string functions */
#include "stdlib.h"		/* (ANSI) miscellaneous standard functions */
#include "rdslib.h"		/* functions from Reliable Data Structures in C */
#endif
